// AecL21.cpp : implementation file
//

#include "stdafx.h"
#include "AecMfc32TimeCode.h"
#include "AecL21.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAecL21 dialog


CAecL21::CAecL21(CWnd* pParent /*=NULL*/)
	: CDialog(CAecL21::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAecL21)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pMainDlg = pParent;
	hFile = NULL;
	OnButton0time();	//initialize "start" time
	m_iSave = 0;
	m_iSaveLoopCnt = 0;
}



CAecL21::~CAecL21()
{
	if (hFile)
	{
		FlushFileBuffers(hFile);
		CloseHandle(hFile);
		hFile = NULL;
	}

}


/*
CAec::~CAec()
{

	if (ISRRun)
	{
		//clear the IRQ interrupt enable ....
		DoISR(false);
		Sleep(200);
	}
}
  */


void CAecL21::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAecL21)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAecL21, CDialog)
	//{{AFX_MSG_MAP(CAecL21)
	ON_BN_CLICKED(IDC_BUTTON_CLR_SCREEN, OnButtonClrScreen)
	ON_BN_CLICKED(IDC_RADIO_F1, OnRadioF1)
	ON_BN_CLICKED(IDC_RADIO_F2, OnRadioF2)
	ON_BN_CLICKED(IDC_RADIO_CC1, OnRadioCc1)
	ON_BN_CLICKED(IDC_RADIO_CC2, OnRadioCc2)
	ON_BN_CLICKED(IDC_RADIO_T1, OnRadioT1)
	ON_BN_CLICKED(IDC_RADIO_T2, OnRadioT2)
	ON_BN_CLICKED(IDC_RADIO_XDS, OnRadioXds)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_L21, OnButtonCloseL21)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, OnButtonPause)
	ON_BN_CLICKED(IDC_CHECK_SAVE, OnCheckSave)
	ON_BN_CLICKED(IDC_BUTTON_0TIME, OnButton0time)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CAecL21::SendToMain(WPARAM wp, LPARAM lp)
{

	m_pMainDlg->SendMessage(WM_AEC_L21, wp, lp);

}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/////////////////////////////////////////////////////////////////////////////
// CAecL21 message handlers
void CAecL21::OnButtonClrScreen() 
{

	m_L21Index = 0;
	m_iCurrent = 0;
	m_L21SortIndex = 0;
	SetDlgItemText(IDC_EDIT_L21_RAW, " ");
	SetDlgItemText(IDC_EDIT_L21, " ");
	if (m_CurrentChannelSelection == XDS)
		xds.Init();
		
}

void CAecL21::OnRadioF1() 
{
	m_ViewField	= true;	//odd
	m_iCurrent = 0;
	m_L21Index = 0;
	m_L21RollOver = false;
	if (m_CurrentChannelSelection == XDS)
	{
		m_CurrentChannelSelection = C1;
		CheckRadioButton(IDC_RADIO_CC1, IDC_RADIO_XDS, IDC_RADIO_CC1);
	}
}

void CAecL21::OnRadioF2() 
{
	m_ViewField	= false;	//even	
	m_iCurrent = 0;
	m_L21Index = 0;
	m_L21RollOver = false;
}

void CAecL21::OnRadioCc1() 
{
	m_CurrentChannelSelection = C1;	
	m_iCurrent = 0;
	m_L21Index = 0;
	m_L21RollOver = false;
}

void CAecL21::OnRadioCc2() 
{
	m_CurrentChannelSelection = C2;	
	m_iCurrent = 0;
	m_L21Index = 0;
	m_L21RollOver = false;
}

void CAecL21::OnRadioT1() 
{
	m_CurrentChannelSelection = T1;	
	m_iCurrent = 0;
	m_L21Index = 0;
	m_L21RollOver = false;	
}

void CAecL21::OnRadioT2() 
{
	m_CurrentChannelSelection = T2;	
	m_iCurrent = 0;
	m_L21Index = 0;
	m_L21RollOver = false;	
}

void CAecL21::OnRadioXds() 
{
	m_CurrentChannelSelection = XDS;	
	m_iCurrent = 0;
	m_L21Index = 0;
	m_L21RollOver = false;
	m_ViewField	= false;	//even	
	CheckRadioButton(IDC_RADIO_F1, IDC_RADIO_F2, IDC_RADIO_F2);
	
}

void CAecL21::OnButtonCloseL21() 
{
	// TODO: Add your control notification handler code here
	SendToMain(CLOSE, 0);
	
}

//=====================================================================
//DEL void CAecL21::OnOK() 
//DEL {
//DEL 	// TODO: Add extra validation here
//DEL 	SendToMain(CLOSE, 0);
//DEL 	//CDialog::OnOK();
//DEL }

//=====================================================================
void CAecL21::ReceiveData(int len, LPDWORD s)
{
	DWORD dw;
	for (int i =0; i<len; i++)
	{
		dw = s[i];
		if ((dw & 0x01000000) != 0)
		{
			L21overflow++;
		}			
		m_bufferL21[m_L21Index] = s[i];
		m_L21Index++;
		if (m_L21Index >= L21RAWBUFFER_SIZE)
		{
			m_L21MaxIndex = m_L21Index;
			m_L21RollOver = true;
			m_L21Index = 0;
		}
	}
	m_L21Event = TRUE;
	
}

//=====================================================================
//=====================================================================
// print the raw L21 data to the edit box
void CAecL21::OutputRaw()
{
	int i;
	char sRaw[12*L21RAWBUFFER_SIZE];
	char hmsf[13];
	DWORD dw;

	sRaw[0] = 0;
	for (i=0; i < m_L21Index; i++)
	{
		dw = m_bufferL21[i];
		//next line is temp for debug
//		dw = (dw & 0xFF007F7F);	//mask the parity bits
		dw = (dw & 0xFFFF7F7F);	//mask the parity bits	//debug
//		if ((dw & 0x01000000) != 0)
//			MessageBeep(-1);
		wsprintf (hmsf,"%8.8X\t", dw);
		//wsprintf (hmsf,"%8.8X  ", dw);
		//wsprintf (hmsf,"%8.8X  ",m_bufferL21[i]);
		strcat(sRaw, hmsf);
//		if ((i & 0x00000003) == 0x03)
//		{
//			wsprintf (hmsf,"##");
//			//wsprintf (hmsf,"%8.8X  ",m_bufferL21[i]);
//			strcat(sRaw, hmsf);
//		}
	}
	SetDlgItemText(IDC_EDIT_L21_RAW, sRaw);

//	wsprintf (hmsf,"%d overflow", L21overflow);
//	SetDlgItemText(IDC_EDIT_FILE_NAME, hmsf);	//L21overflow
}

/*
	if (strcmp(m_hmsf, hmsf))
	{
		strcpy(m_hmsf, hmsf);
		SetDlgItemText(IDC_XTIMEDATA, sRaw);
	}
  */

//=====================================================================
void CAecL21::OnTimer(UINT nIDEvent) 
{
	//CDialog::OnTimer(nIDEvent);
	
	int i = 0;
	UINT t;

	if (nIDEvent == L21TMREVENT)
	{
		if (m_tmr > 350)	//ready for screen update
		{
			SortL21Data();

			if (!m_pause)
			{
				OutputChoice();
				OutputRaw();
			}
			m_tmr = 0;
			//t = 16;
		}
		//==> the next few lines are for test!
	//	m_dwCntTest++;
	//	ReceiveData(1, &m_dwCntTest);
		// <=== test

		//MessageBeep(-1);
		t = 251;
		m_L21_Timer = SetTimer(L21TMREVENT, t, 0);	//(id, nElapse, NULL)
		m_tmr += t;
	}
	
	
	return;
}

//=====================================================================

BOOL CAecL21::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	L21overflow = 0;
	m_L21MaxIndex = 0;
	m_L21RollOver = false;
	m_L21SortIndex = 0;
	m_channel = 0;
	m_mode = 0;

	m_iCurrent = 0;
	m_L21Index = 0;


	m_CurrentChannel = 0;

	m_channel = 0x01;		//default for CC1
	m_mode = 0x10;
	m_ViewField	= true;	//odd
	CheckRadioButton(IDC_RADIO_F1, IDC_RADIO_F2, IDC_RADIO_F1);
	CheckRadioButton(IDC_RADIO_CC1, IDC_RADIO_XDS, IDC_RADIO_CC1);
	m_CurrentChannelSelection = C1;


	m_dwCntTest = 0;
	m_L21_Timer = SetTimer(L21TMREVENT, 2000, 0);
	m_pause = false;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//=====================================================================
void CAecL21::OnButtonPause()	//IDC_BUTTON_PAUSE
{
	m_pause = ( m_pause ? false : true );	//toggle value	
	//ElapsedTime();
}

//=====================================================================
// go through all of the newly received data and sort into
// the proper "output" strings
void CAecL21::SortL21Data()
{
	int i, j, k;
	if (m_L21RollOver)	//process bytes at end of string
	{
		for (i = m_L21SortIndex; i < m_L21MaxIndex; i++)
		{
			L21SortSingle(m_bufferL21[i]);
		}
		m_L21RollOver = false;
		m_L21SortIndex = 0;
		m_L21MaxIndex = 0;
	}

	j = m_L21SortIndex;
	k = m_L21Index;
	for (i = j; i < k; i++)
	{
		L21SortSingle(m_bufferL21[i]);
		m_L21SortIndex++;
	}

	m_iSaveLoopCnt++;	//inc loop count, only do every 10 loops or so.
	if (m_iSaveLoopCnt > 20)
	{
		m_iSaveLoopCnt = 0;
		CheckToSave();
	}
}

//=====================================================================

void CAecL21::OutputChoice()
{
	//m_Selection
	int i, j, crlf;
	char sChoice[8000];
	char ch[3];
	char ch1, ch2;
	int iCR1 = 0;
	BOOL firstCR = false;

	sChoice[0] = 0;

	switch(m_CurrentChannelSelection)
	{
	case C1:
	case C2:
	case T1:
	case T2:
		m_CRprior = false;
		crlf = 0;
		for (i=0; i < m_iCurrent; i++)
		{
			ch1 = m_sCurrentChannel[i++];
			ch2 = m_sCurrentChannel[i];
			if (ch1 < 0x20)		//we have control....
			{
				ProcessCode(ch1, ch2);
				ch1 = m_char1;
				ch2 = m_char2;
				if (ch1 == 0x0D)	//if CRLF
				{
					if (m_CRprior)
					{
						ch1 = 0;
						ch2 = 0;
					}
					else
					{
						if (!firstCR)
						{
							if (crlf > 0)
							{
								firstCR = true;
								iCR1 = i + 1;
							}
						}
						crlf++;
					}
					m_CRprior = true;
				}
				else if (ch1 != 0)
					m_CRprior = false;	//not null or CRLF
					

//					ch1 = m_char1; //ProcessCode(ch1, ch2);
//					ch2 = m_char2;
//					m_CRprior = true;
//					crlf++;
//				}
//				else
//				{
//					ch1 = 0; //ProcessCode(ch1, ch2);
//					ch2 = 0;
//				}
			}
			else
				m_CRprior = false;

			
			if (ch1 != 0)
			{
				wsprintf (ch,"%c", CheckTranslate(ch1));
				strcat(sChoice, ch);
			}
			if (ch2 != 0)
			{
				wsprintf (ch,"%c", CheckTranslate(ch2));
				strcat(sChoice, ch);
			}
		}
//		if ((crlf > 10) && m_CRprior)
//			m_iCurrent = 0;
//		else if (crlf > 15)
//			m_iCurrent = 0;

//=+
		if (crlf > 15)		//shift the lines UP
		{
//			m_CRprior = false;
//			crlf = 0;
//			k = 0;
			for (i = iCR1, j=0; i < m_iCurrent; i++)
			{
				ch1 = m_sCurrentChannel[i++];
				ch2 = m_sCurrentChannel[i];

				m_sCurrentChannel[j++] = ch1;
				m_sCurrentChannel[j++] = ch2;
//				if (ch1 < 0x20)		//we have control....
//				{
//					if (!m_CRprior)
//					{
//						m_CRprior = true;
//						k++;
//					}
//				}
//				else
//					m_CRprior = false;
//				//==============
//				if (k > 1)
//				{
//					m_sCurrentChannel[j++] = ch1;
//					m_sCurrentChannel[j++] = ch2;
//				}
			}
			m_iCurrent = j;
		}
//=-
		TextToView(sChoice);
		
		break;

	case XDS:
		i = ProcessXDS();
		//for (i = ProcessXDS(), j =0; i < m_iCurrent; i++)
		//	m_sCurrentChannel[j++] = m_sCurrentChannel[i];

		break;
	default:
		break;
	}

	

}

//=====================================================================
BOOL CAecL21::ProcessCode(char ch1, char ch2)
{
	char bTemp2;
	bTemp2 = ch2 & 0xF0;	//mask low nibble
	switch (ch1)
	{
		case 0x11:		//2nd of 3x is special Char
		case 0x19:
			switch (bTemp2)
			{
				case 0x30:
					m_char1 = MapSpecialChar(ch2); //This char is printed at end of this function
					m_char2 = 0;
					break;						
				case 0x50:	//5x	5x&7x are ROW/COLUMN INDENTS
				case 0x70:	//7x
					m_char1 = 0x0D; 
					m_char2 = 0x0A;
					break;
				default:
					m_char1 = 0;
					m_char2 = 0;
					break;
			}	
			break;

		case 0x14:		//2nd of 2x is Misc Control code
		case 0x1C:
		case 0x15:
		case 0x1D:
			switch (bTemp2)
			{
				case 0x20:
					switch (ch2)
					{
						case 0x2F:	//End of caption (flip memories)
							m_char1 = 0x0D; 
							m_char2 = 0x0A;
							break;

						case 0x20:	//resume caption loading
						case 0x29:	//Resume direct captioning								
						case 0x25:	//??roll-up2
						case 0x26:	//??roll-up3
						case 0x27:	//??roll-up4
						case 0x28:	//??Flash On
						case 0x2A:		//Text restart
						case 0x2B:		//resume text display
							m_char1 = 0; 
							m_char2 = 0;
							break;

						case 0x2D:		//carriage return
						case 0x2C:		//Erase displayed memory
						case 0x2E:		//Erase Non-displayed memory
							m_char1 = 0x0D; 
							m_char2 = 0x0A;
							break;

						case 0x21:	//Backspace
							m_char1 = 0x08; 
							m_char2 = 0;
							break;

						case 0x22:	//RES.
						case 0x23:	//RES.
						case 0x24:	//Delete to end of Row
							m_char1 = 0; 
							m_char2 = 0;
							break;

						default:
							m_char1 = 0; 
							m_char2 = 0;
							break;
					}							
				case 0x50:	//5x	5x&7x are ROW/COLUMN INDENTS
				case 0x70:	//7x
					m_char1 = 0x0D; 
					m_char2 = 0x0A;
					break;

				default:
					// could be 4x-7x "PAC" 4x&6x are COLOR
					m_char1 = 0; 
					m_char2 = 0;
					break;
			}
			break;

		case 0x17:		//Tab offsets 1/2/3 colums
		case 0x1F:
			switch (bTemp2)
			{
				case 0x20:
						//put code here to handle the TabOffset
					switch (ch2)
					{
						case 0x23:	//have only 2 chars, not three with this method
						case 0x22:	//
							m_char1 = ' ';
							m_char2 = ' ';
							break;
						case 0x21:	//
							m_char1 = ' ';
							m_char2 = 0;	//Add a "space" instead of tabs for "saving"
						default:
							m_char1 = 0;
							m_char2 = 0;
							break;
					}
					break;						
				case 0x50:	//5x	5x&7x are ROW/COLUMN INDENTS
				case 0x70:	//7x
					m_char1 = 0x0D; 
					m_char2 = 0x0A;
					break;

				default:
					m_char1 = 0;
					m_char2 = 0;
					break;
			}					
			break;
		
		//0x10, 0x12, 0x13, 0x16, 0x18, 0x1A, 0x1B, 0x1E, 
		default:
			switch (bTemp2)
			{
				case 0x50:	//5x	5x&7x are ROW/COLUMN INDENTS
				case 0x70:	//7x
					m_char1 = 0x0D; 
					m_char2 = 0x0A;
					break;
				default:
					m_char1 = 0;
					m_char2 = 0;
					break;
			}	
			break;
	}
	return true;
}

//=====================================================================
char CAecL21::MapSpecialChar(char b)
{
	BYTE c;
	switch (b)
	{
		case 0x30:		//registered trakemark
			c = 0xAE;
			break;
		case 0x31:		//degree sign
			c = 0xB0;
			break;
		case 0x32:		//  1/2
			c = 0xBD;
			break;
		case 0x33:		//Inverse query
			c = 0x20; // ?? so use space??
			break;
		case 0x34:		// trademark TM
			c = 0x99;
			break;
		case 0x35:		// cents sign
			c = 0xA2;
			break;
		case 0x36:		// pound sterling sign
			c = 0xA3;
			break;
		case 0x37:		// music note
			c = 0xB6; // This character is NOT correct, but is one available in most fonts!
			break;
		case 0x38:		// lcase a-w/grave accent
			c = 0xE0;
			break;
		case 0x39:		// transparent space
			c = 0x20; //just use space
			break;
		case 0x3A:		// lcase e-w/grave accent
			c = 0xE8;
			break;
		case 0x3B:		//lcase a-w/circumflex
			c = 0xE2;
			break;
		case 0x3C:		//lcase e-w/circumflex
			c = 0xEA;
			break;
		case 0x3D:		//lcase i-w/circumflex
			c = 0xEE;
			break;
		case 0x3E:		//lcase o-w/circumflex
			c = 0xF4;
			break;
		case 0x3F:		//lcase u-w/circumflex
			c = 0xFB;
			break;
		default:	//should never get this!
			c = 0;
			break;
	}
	return (char)c;
}

//=====================================================================
char CAecL21::CheckTranslate(char ct)
{
	BYTE bStuff;

	switch (ct)
	//switch (bStuff)
	{
		//remap several of the bytes here to get correct char for font used
		case 0x2A:	
			bStuff = 0xE1;
			break;
		case 0x5C:		//
			bStuff = 0xE9;
			break;
		case 0x5E:		//
			bStuff = 0xED;
			break;
		case 0x5F:		//
			bStuff = 0xF3;
			break;
		case 0x60:		//
			bStuff = 0xFA;
			break;
		case 0x7B:		//
			bStuff = 0xE7;
			break;
		case 0x7C:		//
			bStuff = 0xF7;
			break;
		case 0x7D:		//
			bStuff = 0xD1;
			break;
		case 0x7E:		//
			bStuff = 0xF1;
			break;
		case 0x7F:		//Solid Block --> space
			bStuff = ' ';	//
			break;
		default:	//all other data
			bStuff = ct;
			break;
	}
	return (char)bStuff;

}
//=====================================================================
//The format of the DWORD received will be (MSB...LSB)
//    Byte3:Byte2:Byte1:Byte0
//  StatusByte: Reserved  : Character#2 : Character#1
// (Character 1/2 => bit 7 is the parity bit
// StatusByte =>	Bit7 => 4-byte L21 data block is valid
//					Bit6 => odd numbered video field
//					Bit5 => reserved
//					Bit4 => reserved
//					Bit3 => no data (or other error) on L21
//					Bit2 => char #2 parity error
//					Bit1 => char #1 parity error
//					Bit0 => internal buffer overflow
//
//=====================================================================
void CAecL21::L21SortSingle(DWORD dwL21)
{
	BOOL field = false;
	//see if the data is valid and error free
	if ((dwL21 & 0x8F000000) != 0x80000000)
		return; //some error
	if ((dwL21 & 0x00007F7F) == 0)	//we have NO data bits (=zero when parity masked)
		return; //don't save null data!

	if ((dwL21 & 0x0000007F) == 0)	//we have NO data in Char#1 bits (=zero when parity masked)
		return; //don't save null data!
	
	if ((dwL21 & 0x40000000) != 0)	//we have odd number video field
		field = true;

	if (m_ViewField == field)	//if current field matches display choice
	{
		if (m_CurrentChannelSelection == Control(dwL21))	//data is for current channel
		{
			//stuff the two bytes into string!
			//if (m_char1 != 0)	//save only if have non-zero data
			//{
				m_sCurrentChannel[m_iCurrent++] = m_char1;
				m_sSave[m_iSave++] = m_char1;
				m_sCurrentChannel[m_iCurrent++] = m_char2;			
				m_sSave[m_iSave++] = m_char2;
				
				if (m_iCurrent > (MAXCHANNELBUFF-2))	//temp, keep string buffer from overrunning
					m_iCurrent = 0;		//temp
			//}
		}		 
	}
	return;
}

//=====================================================================
//see if this dword switches the data channel!
int CAecL21::Control(DWORD dwQues)
{
	DWBYTES_L21 dwL;
	char bTemp, bTemp2;
	int Channel_Mode = 0;

	dwL.d = dwQues;
	m_char1 = (dwL.b.f & 0x7F); //mask parity bit
	m_char2 = (dwL.b.s & 0x7F); //mask parity bit

	bTemp = (m_char1 & 0x70);	//mask out low nibble and parity bit(7)
	bTemp2 = (m_char2 & 0x70);	//mask out low nibble and parity bit(7)

	//m_channel
	//m_mode

	switch (bTemp)
	{
		case 0x00:	//00-0F
			switch (m_char1)
			{
				//====================
				// XDS Control Codes Func/Class
				case 0x01:	//start Current
					//break;	
				case 0x02:	//continue Current
					//break;	
				case 0x03:	//start Future
					//break;	
				case 0x04:	//continue Future
					//break;	
				case 0x05:	//start Channel
					//break;	
				case 0x06:	//continue Channel
					//break;	
				case 0x07:	//start Misc.
					//break;	
				case 0x08:	//continue Misc.
					//break;	
				case 0x09:	//start PubSvs
					//break;	
				case 0x0A:	//continue PubSvs
					//break;	
				case 0x0B:	//start RES.
					//break;	
				case 0x0C:	//continue RES.
					//break;	
				case 0x0D:	//start Undef.
					//break;	
				case 0x0E:	//continue Undef.
					//break;	
				case 0x0F:	//End All
					//Channel_Mode = XDS;
					m_channel = 0x03;
					m_mode = 0x30;
					break;	
				default:	//0x00
					//channel has no change
					break;
			}
			break;

		case 0x10:	//10-1F

			switch (m_char1)
			{
				//====================
				// channel 1
				case 0x10:		//4x-7x PAC, 2x BkgAttr
					m_channel = 0x01;
					break;
				case 0x11:		//2x/3x for MidRow/Special Char, 4x-7x PAC 
					m_channel = 0x01;
					break;
				case 0x12:		//4x-7x PAC, 2x ExChar Spanish, 3x French
					m_channel = 0x01;
					break;
				case 0x13:		//4x-7x PAC, 2x ExChar Portuguese, 3x German/Danish
					m_channel = 0x01;
					break;
				case 0x14:		//2x for Misc. Control code F1, 4x-7x PAC 
					m_channel = 0x01;
					m_mode = CheckMode(m_char2);
					break;
				case 0x15:		//2x for Misc. Control code F2, 4x-7x PAC 
					m_channel = 0x01;
					m_mode = CheckMode(m_char2);
					break;
				case 0x16:		//4x-7x PAC 
					m_channel = 0x01;
					break;
				case 0x17:		//4x-7x PAC, 2D-2F Bkg&FrgAttr
					m_channel = 0x01;
					break;
				//====================
				// channel 2
				case 0x18:		//4x-7x PAC, 2x BkgAttr
					m_channel = 0x02;
					break;
				case 0x19:		//2x/3x for MidRow/Special Char, 4x-7x PAC
					m_channel = 0x02;
					break;
				case 0x1A:		//4x-7x PAC, 2x ExChar Spanish, 3x French
					m_channel = 0x02;
					break;
				case 0x1B:		//4x-7x PAC, 2x ExChar Portuguese, 3x German/Danish
					m_channel = 0x02;
					break;
				case 0x1C:		//2x for Misc. Control code F1, 4x-7x PAC
					m_channel = 0x02;
					m_mode = CheckMode(m_char2);
					break;
				case 0x1D:		//2x for Misc. Control code F2, 4x-7x PAC
					m_channel = 0x02;
					m_mode = CheckMode(m_char2);
					break;
				case 0x1E:		//4x-7x PAC
					m_channel = 0x02;
					break;
				case 0x1F:		//4x-7x PAC, 2D-2F Bkg&FrgAttr
					m_channel = 0x02;					
					break;
				default:
					break;
			}
			break;

		default:	//20-7F normal chars
			break;

	}

	m_CurrentChannel = m_channel + m_mode;
	return m_CurrentChannel;
}

/*
 C1		0x11
 C2		0x12
 T1		0x21
 T2		0x22
 XDS	0x33
*/
//=====================================================================
int CAecL21::CheckMode(BYTE char2)
{
	int mode;		//comes here if have Char1 = 14h, 15h, 1Ch or 1Dh
	switch (char2)
	{
		//Caption mode
		case 0x20:	//RCL
		case 0x25:	//RU2
		case 0x26:	//RU3
		case 0x27:	//RU4
		case 0x29:	//RDC
		case 0x2F:	//EOC
			mode = 0x10;
			break;
			//Text mode
		case 0x2A:	//TR
		case 0x2B:	//RTD
			mode = 0x20;
			break;
			//no mode set/change
		case 0x21:	//BS
		case 0x22:	//AOF
		case 0x23:	//AON
		case 0x24:	//DER
		case 0x28:	//FON
		case 0x2C:	//EDM
		case 0x2D:	//CR
		case 0x2E:	//ENM
		default:
			mode = m_mode;	
			break;
	}
	return mode;
}

//=====================================================================





int CAecL21::ProcessXDS()
{
	int i;
	char c1, c2;

//	char sXDS[8000];
//	char hmsf[8];	
//	sXDS[0] = 0;
//	for (i=0; i < m_iCurrent; i++)
//	{
//		wsprintf (hmsf,"%2.2X ",m_sCurrentChannel[i]);
//		strcat(sXDS, hmsf);
//	}
//	TextToView(sXDS);
//	return  i;

	for (i=0; i < m_iCurrent; i++)
	{
		c1 = m_sCurrentChannel[i++];
		c2 = m_sCurrentChannel[i];
		xds.Add(c1, c2);
	}
	m_iCurrent = 0;
	TextToView(xds.ScreenData());
	return m_iCurrent;

}

/*

Parse the string and save in several different
sub strings
Then process these subs to get the DATA packets
and "IDs"...

	char ch1, ch2, control, type;
	int  iStart, iFirst, iEnd;

  //find the first START control/type byte pair
	for (i=0; i < m_iCurrent; i++)
	{
		iFirst = i;
		ch1 = m_sCurrentChannel[i++];
		ch2 = m_sCurrentChannel[i];
		//if have ODD value between 01h-0Ch
		if ((ch1 < 0x0F) && (ch1 & 0x01))
		{
			//we have a start code
			iStart = iFirst;
			//see what start code we have
		}


	//m_channel
	//m_mode

	switch (ch1)
	{
		// XDS Control Codes Func/Class
		case 0x01:	//start Current
			m_XDScontrol = CURRENT;
			break;	
		case 0x02:	//continue Current
			m_XDScontrol = CURRENT;
			break;	
		case 0x03:	//start Future
			m_XDScontrol = FUTURE;
			break;	
		case 0x04:	//continue Future
			m_XDScontrol = FUTURE;
			break;	
		case 0x05:	//start Channel
			m_XDScontrol = CHANNEL;
			break;	
		case 0x06:	//continue Channel
			m_XDScontrol = CHANNEL;
			break;	
		case 0x07:	//start Misc.
			m_XDScontrol = MISC;
			break;	
		case 0x08:	//continue Misc.
			m_XDScontrol = MISC;
			break;	
		case 0x09:	//start PubSvc
			m_XDScontrol = PUBSVC;
			break;	
		case 0x0A:	//continue PubSvc
			m_XDScontrol = PUBSVC;
			break;	
		case 0x0B:	//start RES.
			m_XDScontrol = RES;
			break;	
		case 0x0C:	//continue RES.
			m_XDScontrol = RES;
			break;	
		case 0x0D:	//start Undef.
			m_XDScontrol = UNDEF;
			break;	
		case 0x0E:	//continue Undef.
			m_XDScontrol = UNDEF;
			break;	
		case 0x0F:	//End All
			//get ch2, save cks.
			m_XDScontrol = 0;
			break;	
		case 0x00:		//should NOT receive ANY OF THESE values HERE (at ch1)!!!!!			
		case 0x10:		//error1
		case 0x11:
		case 0x12:
		case 0x13:
		case 0x14:
		case 0x15:
		case 0x16:
		case 0x17:
		case 0x18:
		case 0x19:
		case 0x1A:
		case 0x1B:
		case 0x1C:
		case 0x1D:
		case 0x1E:
		case 0x1F:
			break;
		default:	//2x+
			//informational data
			break;
	}


 CURRENT	1
 FUTURE		3
 CHANNEL	5
 MISC		7
 PUBSVC		9
 RES		11
 UNDEF		13

*/

//=====================================================================
void CAecL21::OnCheckSave() 
{
	int i = 0;
	//HANDLE hFile;
//	BOOL ok;

    LPTSTR lpszCurDir,lpszName; 
	//LPTSTR lpszPath;
	//TCHAR tchBuffer[BUFFER]; 
	TCHAR tchName[30]; 

    DWORD cchCurDir, dwPathLen; 
//	DWORD inCountToWrite, outCountWritten;

	//Set "saving" flag
	if (IsDlgButtonChecked(IDC_CHECK_SAVE))
	{
		//get the current date and time
		GetLocalTime(&tmNow);

		//creat a file NAME (use info from 'tmNow' to set
		lpszName = tchName;
		wsprintf(lpszName, "\\CCsave_%2.2d%2.2d%2.2d.txt", tmNow.wDay, tmNow.wHour, tmNow.wMinute);

		//get current directory
		lpszCurDir = tchBuffer; 
		cchCurDir = MAX_PATH;
		dwPathLen = GetCurrentDirectory(cchCurDir, lpszCurDir); 

		//append the path to add the file NAME to open 
		lpszPath = lstrcat(lpszCurDir, lpszName);


		//create file at this directory	
		//CreateFile(lpszPath
		if (hFile)
		{
			FlushFileBuffers(hFile);
			CloseHandle(hFile);
		}
		hFile = CreateFile(lpszPath,GENERIC_WRITE, 0, NULL, 
							CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			MessageBox("error creating SAVE file", "FILE ERROR",MB_OK);
		//IDC_EDIT_FILE_NAME
		SetDlgItemText(IDC_EDIT_FILE_NAME, lpszPath);

	}
	else
	{
		if (hFile)
		{
			FlushFileBuffers(hFile);
			CloseHandle(hFile);
			hFile = NULL;
		}
		//else MessageBeep(-1);
		SetDlgItemText(IDC_EDIT_FILE_NAME, "Press 'Save' to save text in file");

	}
	
}


//=====================================================================
void CAecL21::TextToView(LPCTSTR lpS)
{
	SetDlgItemText(IDC_EDIT_L21, lpS);
}

//=====================================================================
void CAecL21::OnButton0time() 
{
//	DWORD inCountToWrite, outCountWritten;
//	BOOL ok;
//	int i = 0;

	//Get the current time and save to calculate offsets for future
	// time stamps
	GetLocalTime(&tm0);//tmNow
//
//	//write the data to the file
//	//inCountToWrite = 17;
//	inCountToWrite = strlen(lpszPath);
//	//usr "lpszName" for LPCVOID lpBuffer.
//	ok = WriteFile(hFile, lpszPath, inCountToWrite, &outCountWritten, NULL); //not Overlapped
//	i = (int)outCountWritten;
	
}
//=====================================================================
DWORD CAecL21::CalcSeconds(WORD h, WORD m, WORD s)
{
	return (DWORD)((h * 3600) + (m * 60) + s);
}


//=====================================================================
void CAecL21::ElapsedTime()
{

	DWORD dSecNow, dSec0, dDaySec, dSecElapsed, dDays;
	
	//WORD wDaysInYear[] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365};

	WORD wMin, wSec, wDays0, wDaysNow;
	//get the current date and time
	GetLocalTime(&tmNow);
	if (tm0.wDay != tmNow.wDay)
	{
		WORD wDaysInYear[] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365};

		//wDaysInYear

		wDaysNow = 0;
		if (tm0.wYear != tmNow.wYear)
			wDaysNow += 365;
		wDays0 = wDaysInYear[tm0.wMonth] + tm0.wDay;
		wDaysNow += wDaysInYear[tmNow.wMonth] + tmNow.wDay;
		dDays = (DWORD)(wDaysNow - wDays0);



		//do the day rollover "thing"
		
		dDaySec = dDays * 86400;	//days * seconds/day 
		dSecNow = CalcSeconds(tmNow.wHour, tmNow.wMinute, tmNow.wSecond);
		dSec0 = CalcSeconds(tm0.wHour, tm0.wMinute, tm0.wSecond);
		

	}
	else
	{
		dDaySec = 0;
		//do quick calulation hh:mm:ss
		dSecNow = CalcSeconds(tmNow.wHour, tmNow.wMinute, tmNow.wSecond);
		dSec0 = CalcSeconds(tm0.wHour, tm0.wMinute, tm0.wSecond);
	}

	dSecElapsed = dDaySec + dSecNow - dSec0;
	tmNow.wHour = (WORD)(dSecElapsed / 3600);
	wMin = (WORD)(dSecElapsed % 3600);
	tmNow.wMinute = (wMin / 60);
	wSec = (wMin % 60);
	tmNow.wSecond = wSec;
	wsprintf(sElapsed, " %2.2d:%2.2d:%2.2d    ", tmNow.wHour, tmNow.wMinute, tmNow.wSecond);

}

//=====================================================================

	/*
typedef struct _SYSTEMTIME { 
    WORD wYear;		//Specifies the current year. The year must be greater than 1601. 
					//Windows XP: The year cannot be greater than 30827. 
    WORD wMonth;	//January = 1, February = 2...
    WORD wDayOfWeek;//Sunday = 0, Monday = 1... 
    WORD wDay;		//1-31
    WORD wHour;		//0-23hr
    WORD wMinute;	//0-59min
    WORD wSecond;	//0-59sec
    WORD wMilliseconds;		//0-999ms
} SYSTEMTIME, *PSYSTEMTIME; 
  */
//=====================================================================




//=====================================================================


////////////
	/*
	
	int i = 0;
	//HANDLE hFile;
	BOOL ok;

    LPTSTR lpszCurDir,lpszName; 
	//LPTSTR lpszPath;
	//TCHAR tchBuffer[BUFFER]; 
	TCHAR tchName[30]; 

    DWORD cchCurDir, dwPathLen; 
	DWORD inCountToWrite, outCountWritten;


//test of FILE OPEN/SAVE to disk
	//get the current date and time
	GetLocalTime(&tmNow);

	//creat a file NAME (use info from 'tmNow' to set
		//wsprintf(tchName, "%d", i);
		//wsprintf(lpszName, "CC_%2.2X", tmNow.wDay);
	lpszName = tchName;
	wsprintf(lpszName, "\\CCsave_%2.2d%2.2d%2.2d.txt", tmNow.wDay, tmNow.wHour, tmNow.wMinute);
	//lpszName = 

	//get current directory
	lpszCurDir = tchBuffer; 
	cchCurDir = MAX_PATH;
	dwPathLen = GetCurrentDirectory(cchCurDir, lpszCurDir); 

	//append the path to add the file NAME to open 
	lpszPath = lstrcat(lpszCurDir, lpszName);


	//create file at this directory	
	//CreateFile(lpszPath
	hFile = CreateFile(lpszPath,GENERIC_WRITE, 0, NULL, 
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);


	//write the data to the file
	inCountToWrite = 17;
	//usr "lpszName" for LPCVOID lpBuffer.
	ok = WriteFile(hFile, lpszName, inCountToWrite, &outCountWritten, NULL); //not Overlapped
	i = (int)outCountWritten;

	//flush to the disk to complete


	//close file
	CloseHandle(hFile);
	*/
///////////////



void CAecL21::CheckToSave()
{
	DWORD inCountToWrite, outCountWritten;
	int i, j, crlf;
	char sSave[1000];
	char sTempSave[1000];
	char ch[15];
	char ch1, ch2;
	int iCR1 = 0;
	int iLastCR = 0;
	BOOL firstCR = false;
	BOOL bHaveTemp = false;
	BOOL bsSave = false;
	BOOL ok;


	sSave[0] = 0;
	sTempSave[0] = 0;

	switch(m_CurrentChannelSelection)
	{
	case C1:
	case C2:
	case T1:
	case T2:
		m_CRpriorSave = false; 
		crlf = 0;
		for (i=0; i < m_iSave; i++)
		{
			ch1 = m_sSave[i++];
			ch2 = m_sSave[i];
			if (ch1 < 0x20)		//we have control....
			{
				ProcessCode(ch1, ch2);
				ch1 = m_char1;
				ch2 = m_char2;
				if (ch1 == 0x0D)	//if CRLF
				{
					iLastCR = i - 1;	//Save point of last CR
					if (m_CRpriorSave)
					{
						ch1 = 0;
						ch2 = 0;
					}
					else
					{
						if (bHaveTemp)
						{
							bsSave = true;
							strcat(sSave, sTempSave);
							sTempSave[0] = 0;
							bHaveTemp = false;
						}
						if (!firstCR)	//if "firstCR" is still FALSE...
						{
							wsprintf (ch,"%c", ch1);
							strcat(sTempSave, ch);	//save "time stamp" string
							wsprintf (ch,"%c", ch2);
							strcat(sTempSave, ch);	//save "time stamp" string
							//wsprintf (ch,"%c", ch1);
							ElapsedTime();
							strcat(sTempSave, sElapsed);	//save "time stamp" string  (13 Char)
							firstCR = true;
							ch1 = 0;
							ch2 = 0;
						}
						else
						{
							wsprintf (ch,"%c", ch1);
							strcat(sTempSave, ch);	//save "time stamp" string
							wsprintf (ch,"%c", ch2);
							strcat(sTempSave, ch);	//save "time stamp" string
							wsprintf (ch,"             ");
							strcat(sTempSave, ch);	//save NULL"time stamp" string  (13 spaces)
							ch1 = 0;
							ch2 = 0;
						}
						//sTempSave[0] = 0;						
						//crlf++;
					}
					m_CRpriorSave = true;
				}
				else if (ch1 != 0)
					m_CRpriorSave = false;	//not null or CRLF
					
			}
			else
				m_CRpriorSave = false;

			
			if (ch1 != 0)
			{
				wsprintf (ch,"%c", CheckTranslate(ch1));
				strcat(sTempSave, ch);
				bHaveTemp = true;
			}
			if (ch2 != 0)
			{
				wsprintf (ch,"%c", CheckTranslate(ch2));
				strcat(sTempSave, ch);
				bHaveTemp = true;

			}
		}


		//now shift everything down to the last bits of data that followed the last "CRLF"
		for (i = iLastCR, j=0; i < m_iSave; i++)
		{
			ch1 = m_sSave[i++];
			ch2 = m_sSave[i];

			m_sSave[j++] = ch1;
			m_sSave[j++] = ch2;
		}
		m_iSave = j;

		

		//SAVE TO FILE HERE
		//	//write the data to the file
		//	//inCountToWrite = 17;
		if (bsSave)
		{
			inCountToWrite = strlen(sSave);	// 
			//usr "lpszName" for LPCVOID lpBuffer.
			if (hFile)
			{
				ok = WriteFile(hFile, sSave, inCountToWrite, &outCountWritten, NULL); //not Overlapped
				i = (int)outCountWritten;
			}
		}
		//else MessageBeep(-1);
	
		//Zero the string index
		
		break;

	case XDS:
		i = ProcessXDS();
		break;
	default:
		break;
	}

}
